Loading...
Searching...
No Matches
juce::CodeEditorComponent Class Reference

## Detailed Description

A text editor component designed specifically for source code.

This is designed to handle syntax highlighting and fast editing of very large files.

The documentation for this class was generated from the following file:

- juce_gui_extra/code_editor/juce_CodeEditorComponent.h

Inheritance diagram for juce::CodeEditorComponent:

## Classes

struct | State
| Can be used to save and restore the editor's caret position, selection state, etc. More...
struct | ColourScheme
| Defines a syntax highlighting colour scheme. More...

## Public Types

enum | ColourIds { backgroundColourId = 0x1004500 , highlightColourId = 0x1004502 , defaultTextColourId = 0x1004503 , lineNumberBackgroundId = 0x1004504 , lineNumberTextId = 0x1004505 }
| A set of colour IDs to use to change the colour of various aspects of the editor. More...
Public Types inherited from juce::TextInputTarget
enum | VirtualKeyboardType { textKeyboard = 0 , numericKeyboard , decimalKeyboard , urlKeyboard , emailAddressKeyboard , phoneNumberKeyboard , passwordKeyboard }
| A set of possible on-screen keyboard types, for use in the getKeyboardType() method. More...
Public Types inherited from juce::Component
enum class | WindowControlKind { client , caption , minimise , maximise , close , sizeTop , sizeLeft , sizeRight , sizeBottom , sizeTopLeft , sizeTopRight , sizeBottomLeft , sizeBottomRight }
| Types of control that are commonly found in windows, especially title-bars. More...
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions

| CodeEditorComponent (CodeDocument &document, CodeTokeniser *codeTokeniser)
| Creates an editor for a document.
| ~CodeEditorComponent () override
| Destructor.
CodeDocument & | getDocument () const noexcept
| Returns the code document that this component is editing.
void | loadContent (const String &newContent)
| Loads the given content into the document.
float | getCharWidth () const noexcept
| Returns the standard character width.
int | getLineHeight () const noexcept
| Returns the height of a line of text, in pixels.
int | getNumLinesOnScreen () const noexcept
| Returns the number of whole lines visible on the screen, This doesn't include a cut-off line that might be visible at the bottom if the component's height isn't an exact multiple of the line-height.
int | getFirstLineOnScreen () const noexcept
| Returns the index of the first line that's visible at the top of the editor.
int | getNumColumnsOnScreen () const noexcept
| Returns the number of whole columns visible on the screen.
CodeDocument::Position | getCaretPos () const
| Returns the current caret position.
int | getTotalNumChars () const override
| Returns the total number of codepoints in the string.
void | moveCaretTo (const CodeDocument::Position &newPos, bool selecting)
| Moves the caret.
Rectangle< int > | getCharacterBounds (const CodeDocument::Position &pos) const
| Returns the on-screen position of a character in the document.
CodeDocument::Position | getPositionAt (int x, int y) const
| Finds the character at a given on-screen position.
CodeDocument::Position | getSelectionStart () const
| Returns the start of the selection as a position.
CodeDocument::Position | getSelectionEnd () const
| Returns the end of the selection as a position.
void | setLineNumbersShown (bool shouldBeShown)
| Enables or disables the line-number display in the gutter.
int | getCaretPosition () const override
| Returns the number of characters from the beginning of the document to the caret.
int | getCharIndexForPoint (Point< int > point) const override
Rectangle< int > | getCaretRectangleForCharIndex (int index) const override
| Returns the bounds of the caret at a particular location in the text.
RectangleList< int > | getTextBounds (Range< int > textRange) const override
| Returns the bounding box for a range of text in the editor.
bool | moveCaretLeft (bool moveInWholeWordSteps, bool selecting)
bool | moveCaretRight (bool moveInWholeWordSteps, bool selecting)
bool | moveCaretUp (bool selecting)
bool | moveCaretDown (bool selecting)
bool | scrollDown ()
bool | scrollUp ()
bool | pageUp (bool selecting)
bool | pageDown (bool selecting)
bool | moveCaretToTop (bool selecting)
bool | moveCaretToStartOfLine (bool selecting)
bool | moveCaretToEnd (bool selecting)
bool | moveCaretToEndOfLine (bool selecting)
bool | deleteBackwards (bool moveInWholeWordSteps)
bool | deleteForwards (bool moveInWholeWordSteps)
bool | deleteWhitespaceBackwardsToTabStop ()
virtual bool | copyToClipboard ()
virtual bool | cutToClipboard ()
virtual bool | pasteFromClipboard ()
bool | undo ()
bool | redo ()
void | selectRegion (const CodeDocument::Position &start, const CodeDocument::Position &end)
bool | selectAll ()
void | deselectAll ()
void | scrollToLine (int newFirstLineOnScreen)
void | scrollBy (int deltaLines)
void | scrollToColumn (int newFirstColumnOnScreen)
void | scrollToKeepCaretOnScreen ()
void | scrollToKeepLinesOnScreen (Range< int > linesToShow)
void | insertTextAtCaret (const String &textToInsert) override
| Inserts some text, overwriting the selected text region, if there is one.
void | insertTabAtCaret ()
void | indentSelection ()
void | unindentSelection ()
Range< int > | getHighlightedRegion () const override
| Returns the extents of the selected text region, or an empty range if nothing is selected,.
bool | isHighlightActive () const noexcept
void | setHighlightedRegion (const Range< int > &newRange) override
| Sets the currently-selected text region.
String | getTextInRange (const Range< int > &range) const override
| Returns a specified sub-section of the text.
void | setTabSize (int numSpacesPerTab, bool insertSpacesInsteadOfTabCharacters)
| Changes the current tab settings.
int | getTabSize () const noexcept
| Returns the current number of spaces per tab.
bool | areSpacesInsertedForTabs () const
| Returns true if the tab key will insert spaces instead of actual tab characters.
String | getTabString (int numSpaces) const
| Returns a string containing spaces or tab characters to generate the given number of spaces.
void | setFont (const Font &newFont)
| Changes the font.
const Font & | getFont () const noexcept
| Returns the font that the editor is using.
void | setReadOnly (bool shouldBeReadOnly) noexcept
| Makes the editor read-only.
bool | isReadOnly () const noexcept
| Returns true if the editor is set to be read-only.
void | setColourScheme (const ColourScheme &scheme)
| Changes the syntax highlighting scheme.
const ColourScheme & | getColourScheme () const noexcept
| Returns the current syntax highlighting colour scheme.
Colour | getColourForTokenType (int tokenType) const
| Returns one the syntax highlighting colour for the given token.
void | retokenise (int startIndex, int endIndex)
| Rebuilds the syntax highlighting for a section of text.
void | setScrollbarThickness (int thickness)
| Changes the size of the scrollbars.
int | getScrollbarThickness () const noexcept
| Returns the thickness of the scrollbars.
virtual void | handleReturnKey ()
| Called when the return key is pressed - this can be overridden for custom behaviour.
virtual void | handleTabKey ()
| Called when the tab key is pressed - this can be overridden for custom behaviour.
virtual void | handleEscapeKey ()
| Called when the escape key is pressed - this can be overridden for custom behaviour.
virtual void | editorViewportPositionChanged ()
| Called when the view position is scrolled horizontally or vertically.
virtual void | caretPositionMoved ()
| Called when the caret position moves.
virtual void | addPopupMenuItems (PopupMenu &menuToAddTo, const MouseEvent *mouseClickEvent)
| This adds the items to the popup menu.
virtual void | performPopupMenuAction (int menuItemID)
| This is called to perform one of the items that was shown on the popup menu.
void | setCommandManager (ApplicationCommandManager *newManager) noexcept
| Specifies a command-manager which the editor will notify whenever the state of any of its commands changes.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | resized () override
| Called when this component's size has been changed.
bool | keyPressed (const KeyPress &) override
| Called when a key is pressed.
void | mouseDown (const MouseEvent &) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &) override
| Called when a mouse button is released.
void | mouseDoubleClick (const MouseEvent &) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &, const MouseWheelDetails &) override
| Called when the mouse-wheel is moved.
void | focusGained (FocusChangeType) override
| Called to indicate that this component has just acquired the keyboard focus.
void | focusLost (FocusChangeType) override
| Called to indicate that this component has just lost the keyboard focus.
bool | isTextInputActive () const override
| Returns true if this input target is currently accepting input.
void | setTemporaryUnderlining (const Array< Range< int > > &) override
| Sets a number of temporarily underlined sections.
ApplicationCommandTarget * | getNextCommandTarget () override
| This must return the next target to try after this one.
void | getAllCommands (Array< CommandID > &) override
| This must return a complete list of commands that this target can handle.
void | getCommandInfo (CommandID, ApplicationCommandInfo &) override
| This must provide details about one of the commands that this target can perform.
bool | perform (const InvocationInfo &) override
| This must actually perform the specified command.
void | lookAndFeelChanged () override
| Called to let the component react to a change in the look-and-feel setting.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from juce::TextInputTarget
| TextInputTarget ()=default
virtual | ~TextInputTarget ()=default
| Destructor.
Rectangle< int > | getCaretRectangle () const
| Returns the position of the caret, relative to the component's origin.
virtual VirtualKeyboardType | getKeyboardType ()
| Returns the target's preference for the type of keyboard that would be most appropriate.
Public Member Functions inherited from juce::Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
virtual void | visibilityChanged ()
| Called when this component's visibility changes.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setTopRightPosition (Point< int >)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass>
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
virtual WindowControlKind | findControlAtPoint (Point< float >) const
| For components that are added to the desktop, this may be called to determine what kind of control is at particular locations in the window.
virtual void | windowControlClickedClose ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "close" control.
virtual void | windowControlClickedMinimise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "minimise" control.
virtual void | windowControlClickedMaximise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "maximise" control.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f, const ImageType &imageType=NativeImageType{})
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the default metrics kind from the component's LookAndFeel.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | invalidateCachedImageResources ()
| Invalidates cached images, both in the CachedComponentImage (if any) and the image effect state.
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from juce::MouseListener
virtual | ~MouseListener ()=default
| Destructor.
Public Member Functions inherited from juce::ApplicationCommandTarget
| ApplicationCommandTarget ()
| Creates a command target.
virtual | ~ApplicationCommandTarget ()
| Destructor.
bool | invoke (const InvocationInfo &invocationInfo, bool asynchronously)
| Makes this target invoke a command.
bool | invokeDirectly (CommandID commandID, bool asynchronously)
| Invokes a given command directly on this target.
ApplicationCommandTarget * | getTargetForCommand (CommandID commandID)
| Searches this target and all subsequent ones for the first one that can handle the specified command.
bool | isCommandActive (CommandID commandID)
| Checks whether this command can currently be performed by this target.
ApplicationCommandTarget * | findFirstTargetParentComponent ()
| If this object is a Component, this method will search upwards in its current UI hierarchy for the next parent component that implements the ApplicationCommandTarget class.

## Additional Inherited Members

Static Public Member Functions inherited from juce::Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.

## Member Enums

## ColourIds

enum juce::CodeEditorComponent::ColourIds

A set of colour IDs to use to change the colour of various aspects of the editor.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | A colour to use to fill the editor's background.
highlightColourId | The colour to use for the highlighted background under selected text.
defaultTextColourId | The colour to use for text when no syntax colouring is enabled.
lineNumberBackgroundId | The colour to use for filling the background of the line-number gutter.
lineNumberTextId | The colour to use for drawing the line numbers.

## Constructors and Destructors

## CodeEditorComponent()

juce::CodeEditorComponent::CodeEditorComponent | ( | CodeDocument & | document,
|  | CodeTokeniser * | codeTokeniser )

Creates an editor for a document.

The tokeniser object is optional - pass nullptr to disable syntax highlighting. The object that you pass in is not owned or deleted by the editor - you must make sure that it doesn't get deleted while this component is still using it.

See also
  CodeDocument

Referenced by juce::CodeEditorComponent::State::restoreState(), and juce::CodeEditorComponent::State::State().

## ~CodeEditorComponent()

juce::CodeEditorComponent::~CodeEditorComponent | ( |  | ) |

override

Destructor.

## Member Functions

## getDocument()

CodeDocument & juce::CodeEditorComponent::getDocument | ( |  | ) | const

inline noexcept

Returns the code document that this component is editing.

## loadContent()

void juce::CodeEditorComponent::loadContent | ( | const String & | newContent | ) |

Loads the given content into the document.

This will completely reset the CodeDocument object, clear its undo history, and fill it with this text.

## getCharWidth()

float juce::CodeEditorComponent::getCharWidth | ( |  | ) | const

inline noexcept

Returns the standard character width.

## getLineHeight()

int juce::CodeEditorComponent::getLineHeight | ( |  | ) | const

inline noexcept

Returns the height of a line of text, in pixels.

## getNumLinesOnScreen()

int juce::CodeEditorComponent::getNumLinesOnScreen | ( |  | ) | const

inline noexcept

Returns the number of whole lines visible on the screen, This doesn't include a cut-off line that might be visible at the bottom if the component's height isn't an exact multiple of the line-height.

## getFirstLineOnScreen()

int juce::CodeEditorComponent::getFirstLineOnScreen | ( |  | ) | const

inline noexcept

Returns the index of the first line that's visible at the top of the editor.

## getNumColumnsOnScreen()

int juce::CodeEditorComponent::getNumColumnsOnScreen | ( |  | ) | const

inline noexcept

Returns the number of whole columns visible on the screen.

This doesn't include any cut-off columns at the right-hand edge.

## getCaretPos()

CodeDocument::Position juce::CodeEditorComponent::getCaretPos | ( |  | ) | const

inline

Returns the current caret position.

Referenced by getCaretPosition().

## getTotalNumChars()

int juce::CodeEditorComponent::getTotalNumChars | ( |  | ) | const

inline override virtual

Returns the total number of codepoints in the string.

Implements juce::TextInputTarget.

## moveCaretTo()

void juce::CodeEditorComponent::moveCaretTo | ( | const CodeDocument::Position & | newPos,
|  | bool | selecting )

Moves the caret.

If selecting is true, the section of the document between the current caret position and the new one will become selected. If false, any currently selected region will be deselected.

## getCharacterBounds()

Rectangle< int > juce::CodeEditorComponent::getCharacterBounds | ( | const CodeDocument::Position & | pos | ) | const

Returns the on-screen position of a character in the document.

The rectangle returned is relative to this component's top-left origin.

Referenced by getCaretRectangleForCharIndex().

## getPositionAt()

CodeDocument::Position juce::CodeEditorComponent::getPositionAt | ( | int | x,
|  | int | y ) const

Finds the character at a given on-screen position.

The coordinates are relative to this component's top-left origin.

References x, and y.

## getSelectionStart()

CodeDocument::Position juce::CodeEditorComponent::getSelectionStart | ( |  | ) | const

inline

Returns the start of the selection as a position.

## getSelectionEnd()

CodeDocument::Position juce::CodeEditorComponent::getSelectionEnd | ( |  | ) | const

inline

Returns the end of the selection as a position.

## setLineNumbersShown()

void juce::CodeEditorComponent::setLineNumbersShown | ( | bool | shouldBeShown | ) |

Enables or disables the line-number display in the gutter.

## getCaretPosition()

int juce::CodeEditorComponent::getCaretPosition | ( |  | ) | const

inline override virtual

Returns the number of characters from the beginning of the document to the caret.

Implements juce::TextInputTarget.

References getCaretPos().

## getCharIndexForPoint()

int juce::CodeEditorComponent::getCharIndexForPoint | ( | Point< int > | point | ) | const

override virtual

See also
  getPositionAt

Implements juce::TextInputTarget.

## getCaretRectangleForCharIndex()

Rectangle< int > juce::CodeEditorComponent::getCaretRectangleForCharIndex | ( | int | index | ) | const

inline override virtual

Returns the bounds of the caret at a particular location in the text.

Implements juce::TextInputTarget.

References getCharacterBounds().

## getTextBounds()

RectangleList< int > juce::CodeEditorComponent::getTextBounds | ( | Range< int > | textRange | ) | const

override virtual

Returns the bounding box for a range of text in the editor.

As the range may span multiple lines, this method returns a RectangleList.

The bounds are relative to the component's top-left and may extend beyond the bounds of the component if the text is long and word wrapping is disabled.

Implements juce::TextInputTarget.

## moveCaretLeft()

bool juce::CodeEditorComponent::moveCaretLeft | ( | bool | moveInWholeWordSteps,
|  | bool | selecting )

## moveCaretRight()

bool juce::CodeEditorComponent::moveCaretRight | ( | bool | moveInWholeWordSteps,
|  | bool | selecting )

## moveCaretUp()

bool juce::CodeEditorComponent::moveCaretUp | ( | bool | selecting | ) |

## moveCaretDown()

bool juce::CodeEditorComponent::moveCaretDown | ( | bool | selecting | ) |

## scrollDown()

bool juce::CodeEditorComponent::scrollDown | ( |  | ) |

## scrollUp()

bool juce::CodeEditorComponent::scrollUp | ( |  | ) |

## pageUp()

bool juce::CodeEditorComponent::pageUp | ( | bool | selecting | ) |

## pageDown()

bool juce::CodeEditorComponent::pageDown | ( | bool | selecting | ) |

## moveCaretToTop()

bool juce::CodeEditorComponent::moveCaretToTop | ( | bool | selecting | ) |

## moveCaretToStartOfLine()

bool juce::CodeEditorComponent::moveCaretToStartOfLine | ( | bool | selecting | ) |

## moveCaretToEnd()

bool juce::CodeEditorComponent::moveCaretToEnd | ( | bool | selecting | ) |

## moveCaretToEndOfLine()

bool juce::CodeEditorComponent::moveCaretToEndOfLine | ( | bool | selecting | ) |

## deleteBackwards()

bool juce::CodeEditorComponent::deleteBackwards | ( | bool | moveInWholeWordSteps | ) |

## deleteForwards()

bool juce::CodeEditorComponent::deleteForwards | ( | bool | moveInWholeWordSteps | ) |

## deleteWhitespaceBackwardsToTabStop()

bool juce::CodeEditorComponent::deleteWhitespaceBackwardsToTabStop | ( |  | ) |

## copyToClipboard()

virtual bool juce::CodeEditorComponent::copyToClipboard | ( |  | ) |

virtual

## cutToClipboard()

virtual bool juce::CodeEditorComponent::cutToClipboard | ( |  | ) |

virtual

## pasteFromClipboard()

virtual bool juce::CodeEditorComponent::pasteFromClipboard | ( |  | ) |

virtual

## undo()

bool juce::CodeEditorComponent::undo | ( |  | ) |

## redo()

bool juce::CodeEditorComponent::redo | ( |  | ) |

## selectRegion()

void juce::CodeEditorComponent::selectRegion | ( | const CodeDocument::Position & | start,
|  | const CodeDocument::Position & | end )

References juce::end().

## selectAll()

bool juce::CodeEditorComponent::selectAll | ( |  | ) |

## deselectAll()

void juce::CodeEditorComponent::deselectAll | ( |  | ) |

## scrollToLine()

void juce::CodeEditorComponent::scrollToLine | ( | int | newFirstLineOnScreen | ) |

## scrollBy()

void juce::CodeEditorComponent::scrollBy | ( | int | deltaLines | ) |

## scrollToColumn()

void juce::CodeEditorComponent::scrollToColumn | ( | int | newFirstColumnOnScreen | ) |

## scrollToKeepCaretOnScreen()

void juce::CodeEditorComponent::scrollToKeepCaretOnScreen | ( |  | ) |

## scrollToKeepLinesOnScreen()

void juce::CodeEditorComponent::scrollToKeepLinesOnScreen | ( | Range< int > | linesToShow | ) |

## insertTextAtCaret()

void juce::CodeEditorComponent::insertTextAtCaret | ( | const String & | textToInsert | ) |

override virtual

Inserts some text, overwriting the selected text region, if there is one.

Implements juce::TextInputTarget.

## insertTabAtCaret()

void juce::CodeEditorComponent::insertTabAtCaret | ( |  | ) |

## indentSelection()

void juce::CodeEditorComponent::indentSelection | ( |  | ) |

## unindentSelection()

void juce::CodeEditorComponent::unindentSelection | ( |  | ) |

## getHighlightedRegion()

Range< int > juce::CodeEditorComponent::getHighlightedRegion | ( |  | ) | const

override virtual

Returns the extents of the selected text region, or an empty range if nothing is selected,.

Implements juce::TextInputTarget.

## isHighlightActive()

bool juce::CodeEditorComponent::isHighlightActive | ( |  | ) | const

noexcept

## setHighlightedRegion()

void juce::CodeEditorComponent::setHighlightedRegion | ( | const Range< int > & | newRange | ) |

override virtual

Sets the currently-selected text region.

Implements juce::TextInputTarget.

References setHighlightedRegion().

Referenced by setHighlightedRegion().

## getTextInRange()

String juce::CodeEditorComponent::getTextInRange | ( | const Range< int > & | range | ) | const

override virtual

Returns a specified sub-section of the text.

Implements juce::TextInputTarget.

References getTextInRange().

Referenced by getTextInRange().

## setTabSize()

void juce::CodeEditorComponent::setTabSize | ( | int | numSpacesPerTab,
|  | bool | insertSpacesInsteadOfTabCharacters )

Changes the current tab settings.

This lets you change the tab size and whether pressing the tab key inserts a tab character, or its equivalent number of spaces.

## getTabSize()

int juce::CodeEditorComponent::getTabSize | ( |  | ) | const

inline noexcept

Returns the current number of spaces per tab.

See also
  setTabSize

## areSpacesInsertedForTabs()

bool juce::CodeEditorComponent::areSpacesInsertedForTabs | ( |  | ) | const

inline

Returns true if the tab key will insert spaces instead of actual tab characters.

See also
  setTabSize

## getTabString()

String juce::CodeEditorComponent::getTabString | ( | int | numSpaces | ) | const

Returns a string containing spaces or tab characters to generate the given number of spaces.

## setFont()

void juce::CodeEditorComponent::setFont | ( | const Font & | newFont | ) |

Changes the font.

Make sure you only use a fixed-width font, or this component will look pretty nasty!

## getFont()

const Font & juce::CodeEditorComponent::getFont | ( |  | ) | const

inline noexcept

Returns the font that the editor is using.

## setReadOnly()

void juce::CodeEditorComponent::setReadOnly | ( | bool | shouldBeReadOnly | ) |

noexcept

Makes the editor read-only.

## isReadOnly()

bool juce::CodeEditorComponent::isReadOnly | ( |  | ) | const

inline noexcept

Returns true if the editor is set to be read-only.

## setColourScheme()

void juce::CodeEditorComponent::setColourScheme | ( | const ColourScheme & | scheme | ) |

Changes the syntax highlighting scheme.

The token type values are dependent on the tokeniser being used - use CodeTokeniser::getTokenTypes() to get a list of the token types.

See also
  getColourForTokenType

## getColourScheme()

const ColourScheme & juce::CodeEditorComponent::getColourScheme | ( |  | ) | const

inline noexcept

Returns the current syntax highlighting colour scheme.

## getColourForTokenType()

Colour juce::CodeEditorComponent::getColourForTokenType | ( | int | tokenType | ) | const

Returns one the syntax highlighting colour for the given token.

The token type values are dependent on the tokeniser being used.

See also
  setColourScheme

## retokenise()

void juce::CodeEditorComponent::retokenise | ( | int | startIndex,
|  | int | endIndex )

Rebuilds the syntax highlighting for a section of text.

This happens automatically any time the CodeDocument is edited, but this method lets you change text colours even when the CodeDocument hasn't changed.

For example, you could use this to highlight tokens as the cursor moves. To do so you'll need to tell your custom CodeTokeniser where the token you want to highlight is, and make it return a special type of token. Then you should call this method supplying the range of the highlighted text.

See also
  CodeTokeniser

## setScrollbarThickness()

void juce::CodeEditorComponent::setScrollbarThickness | ( | int | thickness | ) |

Changes the size of the scrollbars.

## getScrollbarThickness()

int juce::CodeEditorComponent::getScrollbarThickness | ( |  | ) | const

inline noexcept

Returns the thickness of the scrollbars.

## handleReturnKey()

virtual void juce::CodeEditorComponent::handleReturnKey | ( |  | ) |

virtual

Called when the return key is pressed - this can be overridden for custom behaviour.

## handleTabKey()

virtual void juce::CodeEditorComponent::handleTabKey | ( |  | ) |

virtual

Called when the tab key is pressed - this can be overridden for custom behaviour.

## handleEscapeKey()

virtual void juce::CodeEditorComponent::handleEscapeKey | ( |  | ) |

virtual

Called when the escape key is pressed - this can be overridden for custom behaviour.

## editorViewportPositionChanged()

virtual void juce::CodeEditorComponent::editorViewportPositionChanged | ( |  | ) |

virtual

Called when the view position is scrolled horizontally or vertically.

## caretPositionMoved()

virtual void juce::CodeEditorComponent::caretPositionMoved | ( |  | ) |

virtual

Called when the caret position moves.

## addPopupMenuItems()

virtual void juce::CodeEditorComponent::addPopupMenuItems | ( | PopupMenu & | menuToAddTo,
|  | const MouseEvent * | mouseClickEvent )

virtual

This adds the items to the popup menu.

By default it adds the cut/copy/paste items, but you can override this if you need to replace these with your own items.

If you want to add your own items to the existing ones, you can override this, call the base class's addPopupMenuItems() method, then append your own items.

When the menu has been shown, performPopupMenuAction() will be called to perform the item that the user has chosen.

If this was triggered by a mouse-click, the mouseClickEvent parameter will be a pointer to the info about it, or may be null if the menu is being triggered by some other means.

See also
  performPopupMenuAction, setPopupMenuEnabled, isPopupMenuEnabled

## performPopupMenuAction()

virtual void juce::CodeEditorComponent::performPopupMenuAction | ( | int | menuItemID | ) |

virtual

This is called to perform one of the items that was shown on the popup menu.

If you've overridden addPopupMenuItems(), you should also override this to perform the actions that you've added.

If you've overridden addPopupMenuItems() but have still left the default items on the menu, remember to call the superclass's performPopupMenuAction() so that it can perform the default actions if that's what the user clicked on.

See also
  addPopupMenuItems, setPopupMenuEnabled, isPopupMenuEnabled

## setCommandManager()

void juce::CodeEditorComponent::setCommandManager | ( | ApplicationCommandManager * | newManager | ) |

noexcept

Specifies a command-manager which the editor will notify whenever the state of any of its commands changes.

If you're making use of the editor's ApplicationCommandTarget interface, then you should also use this to tell it which command manager it should use. Make sure that the manager does not go out of scope while the editor is using it. You can pass a nullptr here to disable this.

## paint()

void juce::CodeEditorComponent::paint | ( | Graphics & | g | ) |

override virtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from juce::Component.

## resized()

void juce::CodeEditorComponent::resized | ( |  | ) |

override virtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented from juce::Component.

## keyPressed()

bool juce::CodeEditorComponent::keyPressed | ( | const KeyPress & | key | ) |

override virtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## mouseDown()

void juce::CodeEditorComponent::mouseDown | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::MouseListener.

## mouseDrag()

void juce::CodeEditorComponent::mouseDrag | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse is moved while a button is held down.

When a mouse button is pressed inside a component, that component receives mouseDrag callbacks each time the mouse moves, even if the mouse strays outside the component's bounds.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp, mouseMove, contains, setDragRepeatInterval

Reimplemented from juce::MouseListener.

## mouseUp()

void juce::CodeEditorComponent::mouseUp | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::MouseListener.

## mouseDoubleClick()

void juce::CodeEditorComponent::mouseDoubleClick | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button has been double-clicked on a component.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp

Reimplemented from juce::MouseListener.

## mouseWheelMove()

void juce::CodeEditorComponent::mouseWheelMove | ( | const MouseEvent & | event,
|  | const MouseWheelDetails & | wheel )

override virtual

Called when the mouse-wheel is moved.

This callback is sent to the component that the mouse is over when the wheel is moved.

If not overridden, a component will forward this message to its parent, so that parent components can collect mouse-wheel messages that happen to child components which aren't interested in them.

Parameters

  event | details about the mouse event
  wheel | details about the wheel movement

Reimplemented from juce::MouseListener.

## focusGained()

void juce::CodeEditorComponent::focusGained | ( | FocusChangeType | cause | ) |

override virtual

Called to indicate that this component has just acquired the keyboard focus.

See also
  focusLost, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from juce::Component.

## focusLost()

void juce::CodeEditorComponent::focusLost | ( | FocusChangeType | cause | ) |

override virtual

Called to indicate that this component has just lost the keyboard focus.

See also
  focusGained, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from juce::Component.

## isTextInputActive()

bool juce::CodeEditorComponent::isTextInputActive | ( |  | ) | const

override virtual

Returns true if this input target is currently accepting input.

For example, a text editor might return false if it's in read-only mode.

Implements juce::TextInputTarget.

## setTemporaryUnderlining()

void juce::CodeEditorComponent::setTemporaryUnderlining | ( | const Array< Range< int > > & | underlinedRegions | ) |

override virtual

Sets a number of temporarily underlined sections.

This is needed by MS Windows input method UI.

Implements juce::TextInputTarget.

## getNextCommandTarget()

ApplicationCommandTarget * juce::CodeEditorComponent::getNextCommandTarget | ( |  | ) |

override virtual

This must return the next target to try after this one.

When a command is being sent, and the first target can't handle that command, this method is used to determine the next target that should be tried.

It may return nullptr if it doesn't know of another target.

If your target is a Component, you would usually use the findFirstTargetParentComponent() method to return a parent component that might want to handle it.

See also
  invoke

Implements juce::ApplicationCommandTarget.

References juce::ApplicationCommandTarget::ApplicationCommandTarget().

## getAllCommands()

void juce::CodeEditorComponent::getAllCommands | ( | Array< CommandID > & | commands | ) |

override virtual

This must return a complete list of commands that this target can handle.

Your target should add all the command IDs that it handles to the array that is passed-in.

Implements juce::ApplicationCommandTarget.

## getCommandInfo()

void juce::CodeEditorComponent::getCommandInfo | ( | CommandID | commandID,
|  | ApplicationCommandInfo & | result )

override virtual

This must provide details about one of the commands that this target can perform.

This will be called with one of the command IDs that the target provided in its getAllCommands() methods.

It should fill-in all appropriate fields of the ApplicationCommandInfo structure with suitable information about the command. (The commandID field will already have been filled-in by the caller).

The easiest way to set the info is using the ApplicationCommandInfo::setInfo() method to set all the fields at once.

If the command is currently inactive for some reason, this method must use ApplicationCommandInfo::setActive() to make that clear, (or it should set the isDisabled bit of the ApplicationCommandInfo::flags field).

Any default key-presses for the command should be appended to the ApplicationCommandInfo::defaultKeypresses field.

Note that if you change something that affects the status of the commands that would be returned by this method (e.g. something that makes some commands active or inactive), you should call ApplicationCommandManager::commandStatusChanged() to cause the manager to refresh its status.

Implements juce::ApplicationCommandTarget.

## perform()

bool juce::CodeEditorComponent::perform | ( | const InvocationInfo & | info | ) |

override virtual

This must actually perform the specified command.

If this target is able to perform the command specified by the commandID field of the InvocationInfo structure, then it should do so, and must return true.

If it can't handle this command, it should return false, which tells the caller to pass the command on to the next target in line.

See also
  invoke, ApplicationCommandManager::invoke

Implements juce::ApplicationCommandTarget.

## lookAndFeelChanged()

void juce::CodeEditorComponent::lookAndFeelChanged | ( |  | ) |

override virtual

Called to let the component react to a change in the look-and-feel setting.

When the look-and-feel is changed for a component, this method, repaint(), and colourChanged() are called on the original component and all its children recursively.

It can also be triggered manually by the sendLookAndFeelChange() method, in case an application uses a LookAndFeel class that might have changed internally.

See also
  sendLookAndFeelChange, getLookAndFeel

Reimplemented from juce::Component.

## createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > juce::CodeEditorComponent::createAccessibilityHandler | ( |  | ) |

override virtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from juce::Component.

References juce::Component::withDefaultMetrics().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited